
#define SQR(x) ((x)*(x))	/* macro for square */
#ifndef M_PI			/* in case M_PI not found in math.h */
#define M_PI 3.1415927
#endif
#ifndef M_E
#define M_E 2.718282
#endif

#define MAX_FILENAME_CHARS	320

char	CurrentPath[MAX_FILENAME_CHARS];
char	image_filename[MAX_FILENAME_CHARS],buffer1_name[MAX_FILENAME_CHARS];
char	buffer2_name[MAX_FILENAME_CHARS],buffer3_name[MAX_FILENAME_CHARS];
char	label_filename[MAX_FILENAME_CHARS];
char	file_comments[1000];  /* holds any comments in image header (PPM) */

char	FilenameList[500][MAX_FILENAME_CHARS];
int		TotalFilenames,FilenameIndex;

HWND	MainWnd,SnakeWnd;
HINSTANCE				hInst;						// current instance

		// Display flags
int		ScaleImageToWindow,ShowPixelCoords;
int		TopDispRow,LeftDispCol,MagFact;

		// Image data for current and three buffer display
unsigned char	*OriginalImage,*Buffer1Image,*Buffer2Image,*Buffer3Image;
int				OriginalBPP,Buffer1BPP,Buffer2BPP,Buffer3BPP;
int				ROWS,COLS,ROWS1,COLS1,ROWS2,COLS2,ROWS3,COLS3;

		// Hand-labeling specific globals
unsigned char	*LabelImage;	// has same size as Original (ROWS x COLS)
int				Label,DisplayLabels,LabelColor[256][3];

		// Snakes algorithm globals
#define	MAX_CONTOUR_PTS	  10000
int		*ContourX,*ContourY,TotalContourPoints;
int		SnakesMode;		/* 0=>off, 1=>on */
unsigned char *SnakesImage;
int		SnakesRows,SnakesCols,SnakesBPP,SnakesRunning;

		// STARE specific globals
int		MaskTopRow,MaskBottomRow;
double	MaskCircle[3];
int		NerveRow,NerveCol,NerveRadius;
int		VesselsParameters;	  // selects set of parameters from list

		// Smoothing globals
int		FilterSize;	  /* 0=>3x3, 1=>5x5, 2=>7x7, ... */


		// Function prototypes
LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
BOOL SetFilename(HINSTANCE,HWND,char *,int *);
LRESULT CALLBACK OpenFileProc(HWND,UINT,WPARAM,LPARAM);
int ReadImage(char *,unsigned char **,int *,int *);
int WriteImage(char *,unsigned char *,int,int,int,int);
void MakeDisplayImage(unsigned char *,int,int,int);
void PaintImage();
void DisplayImagePointer(unsigned char **,int *,int *);
void DrawAllPolygons(HWND,int);
void GetPolyLine(HWND,int *,int *,int *,int *);
void GetPolyPoint(HWND,int *,int *);
void GetPolyBox(HWND,int *,int *,int *,int *);
void GetImageValue(int *,int *,int,int,int *,int *,int *);
void SetLabelImage(int,int,int,int,int);
void DrawPixelColor(int,int,int,int,int,int);
void DrawContourOnImage(int,int,int);
LRESULT CALLBACK EditLabelProc(HWND,UINT,WPARAM,LPARAM);
void PaintLabelImage(int,int,int);
void PlotImageLine(unsigned char *, unsigned char *,int,int,int,int *,int);
void RegionProperties(unsigned char *,int,int,int,int,int,int *,int *,int *,double *);
unsigned char *PickBuffer(char *,unsigned char *,int,int,int);
void SobelEdgeDetect(unsigned char *,unsigned char *,unsigned char *,int,int,int);
void ThinEdgeImage(unsigned char *,unsigned char *,int,int);
void MakeCircleIndices(double,double,double,int,int,int *,int *);
void MakeLineIndices(int,int,int,int,int,int,int *,int *);
void MakeCurveIndices(int,int,int,int,int,int,int,int,int,int *,int *);
int gaussj(double **,int,double **,int);
void free_dmatrix(double **,int,int,int,int);
void ThresholdImage(HINSTANCE,HWND,unsigned char *,unsigned char *,int,int);
LRESULT CALLBACK ThresholdProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK MagFactProc(HWND,UINT,WPARAM,LPARAM);
void MakeHistogramImage(unsigned char *,unsigned char *,int,int,int);
void HistogramEqualize(unsigned char *,unsigned char *,int,int,int);
void InvertImage(unsigned char *,unsigned char *,int,int,int);
void GrayImage(unsigned char *,unsigned char *,int,int,int);
void RandomColorImage(unsigned char *,unsigned char *,int,int,int);
void MeanFilter(unsigned char *,unsigned char *,int,int,int,int);
void MedianFilter(unsigned char *,unsigned char *,int,int,int,int);
void ModeFilter(unsigned char *,unsigned char *,int,int,int);
void GaussianFilter(unsigned char *,unsigned char *,int,int,int,int);
//void RunSnakes(HINSTANCE,unsigned char *,int,int,int);
void RunSnakes(HWND);

void ComputeStareMask(unsigned char *,int,int,unsigned char *);
void MakeStareMask(int,int,double *,int,int,unsigned char *);
void Fit_Circle_To_Points(int,int *,int *,double *);
void OverlayStareMask(unsigned char *,int,int,int,unsigned char *);
void CreateVesselsFilters();
void MatchSpatialFilterVessels(unsigned char *,int,int,unsigned char *);
			/* prototypes for probing threshold segmenter */
LRESULT CALLBACK ProbeParamsProc(HWND,UINT,WPARAM,LPARAM);
void ProbeVesselNetwork(unsigned char *,int,int,unsigned char *);
void ClipGrowPoint(unsigned char *,int,int,int,int,int,int);
int GetStartGrowPoint(unsigned char *,unsigned char *,int,int,int,int *,int *,int *,int *);
int ProbeRegion(unsigned char *,unsigned char *,int,int,int,int,int,int,int *,int,
				int *,int *,int *,int *,int *,int);
void ThinPixels(unsigned char *,int,int,int *,int,int);
void BranchesAndEnds(unsigned char *,int,int,int *,int,int *,int *,int *,int *,int,int);
void SegmentCurvature(unsigned char	*,int,int,int,int *,int,int *,int,int *,int,int *,int,double *);
int PaintFill(unsigned char	*,int,int,int,int,int,int,int *,int,int *);
int TraceSegment(unsigned char *,int,int,int,int,int *,int,int *);
void FuzzyConvergence(unsigned char *,int,int,unsigned char *);
void EqualizeIlluminationOnVessels(unsigned char *,unsigned char *,int,int,unsigned char *);
void EqualizeIllumination(unsigned char *,int,int,int,unsigned char *);
void LocateOpticNerve(unsigned char *,int,unsigned char *,int,int,char *,char *,unsigned char *);
