
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <sys/timeb.h>
#include <windows.h>
#include <wingdi.h>
#include <winuser.h>
#include <process.h>    /* _beginthread, _endthread */
#include "resource.h"
#include "globals.h"


#if defined (WIN32)
	#define IS_WIN32	TRUE
#else
	#define IS_WIN32	FALSE
#endif

#define IS_NT	IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S	IS_WIN32 && (BOOL)(!(IS_NT) && \
					(LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95	(BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

//HINSTANCE				hInst;						// current instance
char	textout[MAX_FILENAME_CHARS];
int		LOAD_AT_RUNTIME;							// if image double-clicked

LPCTSTR lpszTitle="Image Analyzer";

BOOL RegisterWin95(CONST WNDCLASS* lpwc);

			/* The following are flags used in batch processing of STARE images */
#define	UNLOAD_BATCH_IMAGE		1	  /* if running only one image, turn this off to keep intermediate results loaded */
#define BENCHMARK_VESSELS		0	  /* turn this on to load GT vessels image for evaluation */
#define BENCHMARK_NERVES		0	  /* turn this on to load nerves-gt for evaluation */
#define REPROCESS_FLAG			0	  /* turn this on to re-run vessels segmentation with equalized image */
#define FORCE_MSF_PROCESS		0	  /* turn this on to force re-computation (even if stored) of msf image */
#define FORCE_VESSELS_PROCESS	0	  /* turn this on to force re-computation (even if stored) of vessels image */
#define FORCE_EQ_PROCESS		0	  /* turn this on to force re-computation (even if stored) of eq image */
#define FIND_NERVE				1	  /* turn this on to run nerve detecton algorithm */


int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				LPTSTR lpCmdLine, int nCmdShow)

{
MSG			msg;
HWND		hWnd;
WNDCLASS	wc,wc_snake;
int			i,j;
FILE		*fpt;

// In Windows 95 or WIndows NT the hPrevInstance will always be NULL.

wc.style=CS_HREDRAW | CS_VREDRAW;
wc.lpfnWndProc=(WNDPROC)WndProc;
wc.cbClsExtra=0;
wc.cbWndExtra=0;
wc.hInstance=hInstance;
wc.hIcon=LoadIcon(hInstance,"ID_STARE_ICON");
wc.hCursor=LoadCursor(NULL,IDC_ARROW);
wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
wc.lpszMenuName="ID_MAIN_MENU";
wc.lpszClassName="STARE";

if (IS_WIN95)
  {
  if (!RegisterWin95(&wc))
    return(FALSE);
  }
else if (!RegisterClass(&wc))
  return(FALSE);

hInst=hInstance;

hWnd=CreateWindow("STARE",lpszTitle,
		WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL,
		CW_USEDEFAULT,0,400,400,NULL,NULL,hInstance,NULL);
if (!hWnd)
  return(FALSE);

if (1)	  /* snake illustration window */
  {
  wc_snake.style=CS_HREDRAW | CS_VREDRAW;
  wc_snake.lpfnWndProc=(WNDPROC)WndProc;
  wc_snake.cbClsExtra=0;
  wc_snake.cbWndExtra=0;
  wc_snake.hInstance=hInstance;
  wc_snake.hIcon=LoadIcon(hInstance,"ID_STARE_ICON");
  wc_snake.hCursor=LoadCursor(NULL,IDC_ARROW);
  wc_snake.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
  wc_snake.lpszMenuName=NULL;
  wc_snake.lpszClassName="SNAKE";
  if (IS_WIN95)
	{
	if (!RegisterWin95(&wc_snake))
	  return(FALSE);
	}
  else if (!RegisterClass(&wc_snake))
	return(FALSE);
  SnakeWnd=CreateWindow("Snake","Snake",
		  WS_OVERLAPPEDWINDOW,
		  CW_USEDEFAULT,0,400,400,NULL,NULL,hInstance,NULL);
  }


ShowScrollBar(hWnd,SB_BOTH,FALSE);
ShowWindow(hWnd,nCmdShow | SW_MAXIMIZE);
UpdateWindow(hWnd);
MainWnd=hWnd;
ScaleImageToWindow=1;
MagFact=1;
TopDispRow=LeftDispCol=0;
ShowPixelCoords=0;
DisplayLabels=0;
Label=255;
LabelColor[255][0]=0; LabelColor[255][1]=0; LabelColor[255][2]=255;
LabelColor[0][0]=LabelColor[0][1]=LabelColor[0][2]=0;
for (i=1; i<255; i++)
  for (j=0; j<3; j++)
    LabelColor[i][j]=(rand() % 256);

SnakesMode=0;
ContourX=(int *)calloc(MAX_CONTOUR_PTS,sizeof(int));
ContourY=(int *)calloc(MAX_CONTOUR_PTS,sizeof(int));
TotalContourPoints=0;

MaskTopRow=0; MaskBottomRow=9999;
MaskCircle[0]=300.0; MaskCircle[1]=300.0; MaskCircle[2]=999.9;
VesselsParameters=6;
NerveRadius=60;		/* measured appx 120 pixels for average nerve diameter in 81 images */

FilterSize=0;		/* 3x3 default */

strcpy(CurrentPath,"C:\\Images\\Stare\\");
// strcpy(CurrentPath,"C:\\MV\\");
strcpy(image_filename,"");
LOAD_AT_RUNTIME=0;
if (strlen(lpCmdLine) > 0)
  {
  if (lpCmdLine[0] == '"')
	{
	strcpy(image_filename,&(lpCmdLine[1]));
	image_filename[strlen(image_filename)-1]='\0';
	}
  else
    strcpy(image_filename,lpCmdLine);
  LOAD_AT_RUNTIME=1;
  PostMessage(hWnd,WM_COMMAND,ID_FILE_LOADIMAGE,0);
  }
strcpy(textout,"No image loaded");
OriginalImage=NULL;
Buffer1Image=Buffer2Image=Buffer3Image=NULL;
ROWS=COLS=0;

		/* check for master list; allows scrolling through multiple files using keystrokes */
TotalFilenames=0;
fpt=fopen("IMAGE_LIST.txt","r");
if (fpt == NULL)
  fpt=fopen("..\\IMAGE_LIST.txt","r");
if (fpt != NULL)
  {
  while (1)
	{
	i=fscanf(fpt,"%s",FilenameList[TotalFilenames]);
	if (i != 1)
	  break;
	TotalFilenames++;
	}
  fclose(fpt);
  }
FilenameIndex=-1;	/* start with none loaded */

MakeDisplayImage(NULL,0,0,0);
InvalidateRect(hWnd,NULL,TRUE);
UpdateWindow(hWnd);

while (GetMessage(&msg,NULL,0,0))
  {
  TranslateMessage(&msg);
  DispatchMessage(&msg);
  }
return(msg.wParam);
}



BOOL RegisterWin95(CONST WNDCLASS* lpwc)

{
WNDCLASSEX wcex;

wcex.style=lpwc->style;
wcex.lpfnWndProc=lpwc->lpfnWndProc;
wcex.cbClsExtra=lpwc->cbClsExtra;
wcex.cbWndExtra=lpwc->cbWndExtra;
wcex.hInstance=lpwc->hInstance;
wcex.hIcon=lpwc->hIcon;
wcex.hCursor=lpwc->hCursor;
wcex.hbrBackground=lpwc->hbrBackground;
wcex.lpszMenuName=lpwc->lpszMenuName;
wcex.lpszClassName=lpwc->lpszClassName;
		// Added elements for Windows 95:
wcex.cbSize=sizeof(WNDCLASSEX);
wcex.hIconSm=LoadIcon(wcex.hInstance,"ID_STARE_ICON");
return (RegisterClassEx(&wcex));
}



LRESULT CALLBACK WndProc (HWND hWnd, UINT uMsg,
		WPARAM wParam, LPARAM lParam)

{
HMENU				hMenu;
HDC					hDC;
RECT				TextRect;
HBRUSH				DrawBrush;
OPENFILENAME		ofn;
static unsigned char *ActiveImage;
unsigned char		*OutputImage;
static int			ActiveROWS,ActiveCOLS,ActiveBPP;
int					xPos,yPos,red,green,blue,i,r,c,r2,c2,tp,indices[2000];
int					StartRow,StartCol,EndRow,EndCol,image_type,EnableValue;
int					RegionX,RegionY,RegionArea;
double				RegionCompactness;
static int			CircleRow,CircleCol,CircleRadius;
// struct _timeb		timebuffer1,timebuffer2;
char				text[200],text2[200],image_ID[50],GT_image_ID[50];
int					true_pos,false_pos,true_total,false_total,report_line;
FILE				*fpt_batch,*fpt,*fpt_results;
float				roc_tpr,roc_fpr;
int					matches,total_images,indecisions;

switch (uMsg)
  {
  case WM_COMMAND:
    switch (LOWORD(wParam))
      {
	  case ID_DISPLAY_CLIPIMAGECOORDINATES:
		GetPolyBox(hWnd,&StartCol,&StartRow,&EndCol,&EndRow);
	    GetImageValue(&StartCol,&StartRow,ActiveROWS,ActiveCOLS,&red,&green,&blue);
	    GetImageValue(&EndCol,&EndRow,ActiveROWS,ActiveCOLS,&red,&green,&blue);
		OutputImage=PickBuffer("Clipped",ActiveImage,EndRow-StartRow+1,EndCol-StartCol+1,ActiveBPP);
		for (r=StartRow; r<=EndRow; r++)
		  for (c=StartCol; c<=EndCol; c++)
			for (i=0; i<ActiveBPP; i++)
			  OutputImage[((r-StartRow)*(EndCol-StartCol+1)+c-StartCol)*ActiveBPP+i]=
						ActiveImage[(r*ActiveCOLS+c)*ActiveBPP+i];
		strcpy(textout,"Clipped");
		ActiveImage=OutputImage; ActiveROWS=EndRow-StartRow+1; ActiveCOLS=EndCol-StartCol+1;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_DISPLAY_PLOTSIGNAL:
		GetPolyLine(hWnd,&StartCol,&StartRow,&EndCol,&EndRow);
	    GetImageValue(&StartCol,&StartRow,ActiveROWS,ActiveCOLS,&red,&green,&blue);
	    GetImageValue(&EndCol,&EndRow,ActiveROWS,ActiveCOLS,&red,&green,&blue);
		MakeLineIndices(StartCol,StartRow,EndCol,EndRow,ActiveROWS,ActiveCOLS,indices,&tp);
		OutputImage=PickBuffer("Signal plot",ActiveImage,256,tp,ActiveBPP);
		PlotImageLine(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,ActiveBPP,indices,tp);
		strcpy(textout,"Signal plot");
		ActiveImage=OutputImage; ActiveROWS=256; ActiveCOLS=tp;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_DISPLAY_REGION_PROPERTIES:
		GetPolyPoint(hWnd,&StartCol,&StartRow);
	    GetImageValue(&StartCol,&StartRow,ActiveROWS,ActiveCOLS,&red,&green,&blue);
		RegionProperties(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP,StartRow,StartCol,
						  &RegionArea,&RegionX,&RegionY,&RegionCompactness);
		sprintf(text,"Color %d,%d,%d has area %d centered at %d,%d with compactness %lf",
						  red,green,blue,RegionArea,RegionX,RegionY,RegionCompactness);
		MessageBox(NULL,text,"Region properties:",MB_OK | MB_APPLMODAL);
		break;
	  case ID_DISPLAY_SHOWPIXELCOORDINATES:
		ShowPixelCoords=(ShowPixelCoords+1)%2;
		hMenu=GetMenu(MainWnd);
		if (ShowPixelCoords == 1)
		  CheckMenuItem(hMenu,ID_DISPLAY_SHOWPIXELCOORDINATES,MF_BYCOMMAND | MF_CHECKED);
		else
		  {
		  CheckMenuItem(hMenu,ID_DISPLAY_SHOWPIXELCOORDINATES,MF_BYCOMMAND | MF_UNCHECKED);
		  MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		  InvalidateRect(hWnd,NULL,TRUE);
		  UpdateWindow(hWnd);
		  }
		break;
	  case ID_DISPLAY_SHOWCOMMENTS:
		MessageBox(NULL,file_comments,"Comments in file:",MB_OK | MB_APPLMODAL);
		break;
      case ID_FILE_LOADIMAGE:
		if (LOAD_AT_RUNTIME)
		  LOAD_AT_RUNTIME=0;
		else
		  {
/*
		  image_type=1;
		  if (!(SetFilename(hInst,hWnd,image_filename,&image_type)))
		    break;
*/
		  memset(&(ofn),0,sizeof(ofn));
		  ofn.lStructSize=sizeof(ofn);
		  ofn.lpstrFile=image_filename;
		  image_filename[0]=0;
		  ofn.nMaxFile=MAX_FILENAME_CHARS;
		  ofn.Flags=OFN_EXPLORER | OFN_HIDEREADONLY;
		  ofn.lpstrFilter = "PPM files\0*.ppm\0JPG files\0*.jpg\0All files\0*.*\0\0";
		  ofn.nFilterIndex=1;
		  if (!( GetOpenFileName(&ofn))  ||  image_filename[0] == '\0')
			break;		/* user cancelled load */
		  image_type=ofn.nFilterIndex;

		  if (OriginalImage != NULL)
		    free(OriginalImage);
		  OriginalImage=NULL;
		  ROWS=COLS=0;
		  if (Buffer1Image != NULL) { free(Buffer1Image); Buffer1Image=NULL; }
		  if (Buffer2Image != NULL) { free(Buffer2Image); Buffer2Image=NULL; }
		  if (Buffer3Image != NULL) { free(Buffer3Image); Buffer3Image=NULL; }
		  if (LabelImage != NULL) { free(LabelImage); LabelImage=NULL; }
		  }
		if ((OriginalBPP=ReadImage(image_filename,&OriginalImage,&ROWS,&COLS)) == 0)
		  {
		  MessageBox(hWnd,image_filename,"Cannot read file:",MB_APPLMODAL | MB_OK);
		  strcpy(image_filename,"");
		  ROWS=COLS=OriginalBPP=0;
		  OriginalImage=NULL;
		  strcpy(textout,"No image loaded");
		  strcpy(image_filename,"");
		  }
		else
		  {
		  strcpy(textout,image_filename);
		  }
		ActiveBPP=OriginalBPP;
		ActiveImage=OriginalImage; ActiveROWS=ROWS; ActiveCOLS=COLS;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_FILE_SAVE:
/*
		image_type=0;
		if (!(SetFilename(hInst,hWnd,image_filename,&image_type)))
		  break;
*/
		memset(&(ofn),0,sizeof(ofn));
		ofn.lStructSize=sizeof(ofn);
		ofn.lpstrFile=image_filename;
		image_filename[0]=0;
		ofn.nMaxFile=MAX_FILENAME_CHARS;
		ofn.Flags=OFN_EXPLORER | OFN_HIDEREADONLY;
		ofn.lpstrFilter = "PPM files\0*.ppm\0JPG files\0*.jpg\0All files\0*.*\0\0";
		ofn.nFilterIndex=1;
		if (!( GetSaveFileName(&ofn))  ||  image_filename[0] == '\0')
		  break;		/* user cancelled load */
		image_type=ofn.nFilterIndex;
		if (image_type == 1  &&  strcmp(&(image_filename[strlen(image_filename)-4]),".ppm") != 0)
		  strcat(image_filename,".ppm");
		if (image_type == 2  &&  strcmp(&(image_filename[strlen(image_filename)-4]),".jpg") != 0)
		  strcat(image_filename,".jpg");

		if (WriteImage(image_filename,ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP,image_type) == 0)
		  MessageBox(hWnd,image_filename,"Cannot write file:",MB_APPLMODAL | MB_OK);
		else
		  MessageBox(hWnd,image_filename,"File saved:",MB_APPLMODAL | MB_OK);
		break;
	  case ID_FILE_DISPLAY_SAVE:
		image_type=0;
		if (!(SetFilename(hInst,hWnd,image_filename,&image_type)))
		  break;
		DisplayImagePointer(&OutputImage,&r,&c);
		if (WriteImage(image_filename,OutputImage,r,c,3,image_type) == 0)
		  MessageBox(hWnd,image_filename,"Cannot write file:",MB_APPLMODAL | MB_OK);
		else
		  MessageBox(hWnd,image_filename,"File saved:",MB_APPLMODAL | MB_OK);
		free(OutputImage);
		break;
	  case ID_FILE_BATCHRUN:
		//for (VesselsParameters=0; VesselsParameters <10; VesselsParameters++) {
		VesselsParameters=5;
		matches=total_images=indecisions=0;
		roc_tpr=roc_fpr=0.0;
		if ((fpt_batch=fopen("C:\\Images\\STARE\\batch-all.txt","r")) == NULL)
		  {
		  MessageBox(NULL,"Unable to open C:\\Images\\STARE\\batch-all.txt","Input file:",MB_OK | MB_APPLMODAL);
		  break;
		  }
		report_line=15;	// for outputting text on completion of each image
		//sprintf(text,"C:\\Images\\STARE\\results%d.txt",VesselsParameters);
		sprintf(text,"C:\\Images\\STARE\\results-nerves.txt");
		fpt_results=fopen(text,"w");
		while (fscanf(fpt_batch,"%s",image_ID) == 1)
		  {
				  // clear arrays for batch processing -- will not display any images
		  if (OriginalImage != NULL)
		    free(OriginalImage);
		  OriginalImage=NULL;
		  ROWS=COLS=0;
		  if (Buffer1Image != NULL) { free(Buffer1Image); Buffer1Image=NULL; }
		  if (Buffer2Image != NULL) { free(Buffer2Image); Buffer2Image=NULL; }
		  if (Buffer3Image != NULL) { free(Buffer3Image); Buffer3Image=NULL; }
		  if (LabelImage != NULL) { free(LabelImage); LabelImage=NULL; }
		  sprintf(text,"C:\\Images\\STARE\\working-size\\%s.ppm",image_ID);
		  if ((OriginalBPP=ReadImage(text,&OriginalImage,&ROWS,&COLS)) == 0)
			continue;
				  // compute mask and apply to original image -- this is quick
		  ComputeStareMask(OriginalImage,ROWS,COLS,NULL);	// mask stored in global variables
		  OutputImage=PickBuffer("Mask Overlayed",OriginalImage,ROWS,COLS,3);
		  OverlayStareMask(OriginalImage,ROWS,COLS,3,OutputImage);
		  free(OriginalImage); OriginalImage=OutputImage; Buffer1Image=NULL;

				  // read in equalized image and replace green band
		  if (REPROCESS_FLAG)
			{
			sprintf(text,"C:\\Images\\STARE\\nerves\\%s-eq.ppm",image_ID);
			if ((ReadImage(text,&Buffer1Image,&ROWS1,&COLS1)) == 0)
			  MessageBox(NULL,text,"Unable to read for REPROCESS:",MB_OK | MB_APPLMODAL);
			else
			  {
			  for (i=0; i<ROWS*COLS; i++)
				OriginalImage[i*3+1]=Buffer1Image[i];
			  free(Buffer1Image); Buffer1Image=NULL;
			  }
			}

				  // compute MSF -- check to see if already stored, loading if found (computing is slow)
		  sprintf(text,"C:\\Images\\STARE\\msf\\%s-msf.ppm",image_ID);
		  if (FORCE_MSF_PROCESS  ||  (ReadImage(text,&Buffer1Image,&ROWS1,&COLS1)) == 0)
			{
		    OutputImage=PickBuffer("MSF",OriginalImage,ROWS,COLS,1);  // will be Buffer1Image
		    MatchSpatialFilterVessels(OriginalImage,ROWS,COLS,OutputImage);
			WriteImage(text,OutputImage,ROWS,COLS,1,1);
			}
				  // segment vessels -- check to see if already stored, loading if found (computing is slow)
		  sprintf(text,"C:\\Images\\STARE\\vessels\\%s-vessels%d.ppm",image_ID,VesselsParameters);
		  if (FORCE_VESSELS_PROCESS  ||  (ReadImage(text,&Buffer2Image,&ROWS2,&COLS2)) == 0)
			{
		    OutputImage=PickBuffer("Vessels",OriginalImage,ROWS,COLS,1);  // will be Buffer2Image
		    ProbeVesselNetwork(Buffer1Image,ROWS,COLS,OutputImage);
			WriteImage(text,OutputImage,ROWS,COLS,1,1);
			}
				  // benchmark vessels -- report TP/FP on text display
		  if (BENCHMARK_VESSELS)
			{
		    sprintf(text,"C:\\Images\\STARE\\hand-vessels\\%s.ah.ppm",image_ID);
		    if ((ReadImage(text,&Buffer3Image,&ROWS3,&COLS3)) == 0)
			  sprintf(textout,"%s not found",text);
		    else
			  {
			  true_pos=false_pos=true_total=false_total=0;
			  for (i=0; i<ROWS*COLS; i++)
				{
			    if (Buffer3Image[i] == 255) true_total++; else false_total++;
			    if (Buffer2Image[i] >= 4)
				  if (Buffer3Image[i] == 255) true_pos++; else false_pos++;
				}
			  sprintf(textout,"TPR = %f    FPR = %f\n",(float)true_pos/(float)true_total,(float)false_pos/(float)false_total);
			  }
		    hDC=GetDC(MainWnd);
		    TextOut(hDC,0,report_line,textout,strlen(textout));
			fprintf(fpt_results,"%s",textout);
			roc_tpr+=((float)true_pos/(float)true_total);
			roc_fpr+=((float)false_pos/(float)false_total);
		    ReleaseDC(MainWnd,hDC);
		    report_line+=15;
			if (report_line >=300)
			  report_line=15;
			}
		  if (FIND_NERVE) {
				  // equalize illumination -- if already stored, load (computing is slow)
		  if (Buffer3Image != NULL)				  // may have been used for GT vessels
			{ free(Buffer3Image); Buffer3Image=NULL; }
		  sprintf(text,"C:\\Images\\STARE\\nerves\\%s-eq.ppm",image_ID);
		  if (FORCE_EQ_PROCESS  ||  (ReadImage(text,&Buffer3Image,&ROWS3,&COLS3)) == 0)
			{
		    OutputImage=PickBuffer("Equalized",OriginalImage,ROWS,COLS,3);  // will be Buffer3Image
		    EqualizeIllumination(OriginalImage,ROWS,COLS,3,OutputImage);
			WriteImage(text,OutputImage,ROWS,COLS,3,1);
			}

		  if (0)  // copy original into equalized in order to evaluate nerve detection without equalization
		    for (i=0; i<ROWS*COLS*3; i++)
			  Buffer3Image[i]=OriginalImage[i];

				  // find the optic nerve
		  if (Buffer1Image != NULL)				  // was used for MSF image
			{ free(Buffer1Image); Buffer1Image=NULL; }
		  OutputImage=PickBuffer("Nerve",OriginalImage,ROWS,COLS,1);  // will be Buffer1Image
		  LocateOpticNerve(Buffer3Image,3,Buffer2Image,ROWS,COLS,"C:\\Images\\STARE\\vessels",image_ID,OutputImage);
		  for (i=0; i<ROWS*COLS; i++)		/* copy original image into output for showing "X" */
			OutputImage[i]=OriginalImage[i*3+1];
		  if (NerveRow != -1  &&  NerveCol != -1)
			{								/* Mark location of optic nerve with 'X' */
			for (r=NerveRow-NerveRadius/2,r2=-NerveRadius/2; r<=NerveRow+NerveRadius/2; r++,r2++)
			  for (c=NerveCol-NerveRadius/2,c2=-NerveRadius/2; c<=NerveCol+NerveRadius/2; c++,c2++)
				{
			    if (abs(abs(r2)-abs(c2)) > 8  ||  r < 0  ||  r >= ROWS  ||  c < 0  ||  c >= COLS)
				  continue;
				OutputImage[r*COLS+c]=255;
				}
			}
		  sprintf(text,"C:\\Images\\STARE\\nerves\\%s-nerve.ppm",image_ID);
		  WriteImage(text,OutputImage,ROWS,COLS,1,1);
		  fprintf(fpt_results,"%s %d %d\n",image_ID,NerveRow,NerveCol);
				  // benchmark nerves -- report distance on text display
		  if (BENCHMARK_NERVES)
			{
			if ((fpt=fopen("C:\\Images\\STARE\\nerves-gt.txt","r")) == NULL)
			  sprintf(textout,"nerves-gt file not found");
			else
			  {
			  sprintf(textout,"%s not found in nerves-gt file",image_ID);
			  while (fscanf(fpt,"%s %d %d %s %s",GT_image_ID,&yPos,&xPos,text,text2) == 5)
				{
				if (strcmp(GT_image_ID,image_ID) == 0)
				  {
				  if (NerveCol == -1  &&  NerveRow == -1)
					{
					sprintf(textout,"%s 2",image_ID);
					indecisions++;
					}
				  else if (sqrt((double)(SQR(xPos-NerveCol)+SQR(yPos-NerveRow))) < (double)NerveRadius)
					{
					sprintf(textout,"%s 1",image_ID);
					matches++;
					}
				  else
					sprintf(textout,"%s 0",image_ID);
				  total_images++;
				  }
				}
			  fclose(fpt);
			  }
		    hDC=GetDC(MainWnd);
		    TextOut(hDC,0,report_line,textout,strlen(textout));
		    ReleaseDC(MainWnd,hDC);
			fprintf(fpt_results,"%s\n",textout);
		    report_line+=15;
			if (report_line >=300)
			  report_line=15;
			}
			}	// end if FIND_NERVE
				  // for debugging; if only run one image, can leave results to look at
		  if (!UNLOAD_BATCH_IMAGE)
			{
		    ActiveImage=Buffer3Image;
		    ROWS1=ROWS2=ROWS3=ActiveROWS=ROWS;
		    COLS1=COLS2=COLS3=ActiveCOLS=COLS;
		    Buffer1BPP=Buffer2BPP=Buffer3BPP=ActiveBPP=1;
			}
		  }
		fclose(fpt_batch);
		if (BENCHMARK_NERVES)
		  fprintf(fpt_results,"matching rate = %d/%d = %f \t indecisions = %d\n",matches,total_images,(float)matches/(float)total_images,indecisions);
		fclose(fpt_results);
				  // free up image arrays and leave as "no image loaded"
		if (UNLOAD_BATCH_IMAGE)
		  {
	      if (OriginalImage != NULL)
		    free(OriginalImage);
		  OriginalImage=NULL;
		  ROWS=COLS=OriginalBPP=0;
		  if (Buffer1Image != NULL) { free(Buffer1Image); Buffer1Image=NULL; }
		  if (Buffer2Image != NULL) { free(Buffer2Image); Buffer2Image=NULL; }
		  if (Buffer3Image != NULL) { free(Buffer3Image); Buffer3Image=NULL; }
		  if (LabelImage != NULL) { free(LabelImage); LabelImage=NULL; }
		  strcpy(textout,"No image loaded");
		  strcpy(image_filename,"");
		  }

		//}  // closing bracket is for looping over VesselParameters
		break;

	  case ID_WINDOW_LASTLOADED:
		strcpy(textout,image_filename);
		ActiveImage=OriginalImage; ActiveROWS=ROWS; ActiveCOLS=COLS; ActiveBPP=OriginalBPP;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_WINDOW_BUFFER1:
		strcpy(textout,buffer1_name);
		ActiveImage=Buffer1Image; ActiveROWS=ROWS1; ActiveCOLS=COLS1; ActiveBPP=Buffer1BPP;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_WINDOW_BUFFER2:
		strcpy(textout,buffer2_name);
		ActiveImage=Buffer2Image; ActiveROWS=ROWS2; ActiveCOLS=COLS2; ActiveBPP=Buffer2BPP;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_WINDOW_BUFFER3:
		strcpy(textout,buffer3_name);
		ActiveImage=Buffer3Image; ActiveROWS=ROWS3; ActiveCOLS=COLS3; ActiveBPP=Buffer3BPP;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_WINDOW_LABELS:
		strcpy(textout,label_filename);
		ActiveImage=LabelImage; ActiveROWS=ROWS; ActiveCOLS=COLS; ActiveBPP=1;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_SMOOTH_MEAN:
		OutputImage=PickBuffer("Mean filtered",ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		MeanFilter(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,ActiveBPP,FilterSize);
		strcpy(textout,"Mean filtered");
		ActiveImage=OutputImage;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_SMOOTH_MEDIAN:
		OutputImage=PickBuffer("Median filtered",ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		MedianFilter(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,ActiveBPP,FilterSize);
		strcpy(textout,"Median filtered");
		ActiveImage=OutputImage;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_SMOOTH_MODE:
		if (ActiveBPP != 1)
		  {
		  MessageBox(hWnd,"Image must be single-band (greyscale)","Not applicable",MB_OK | MB_APPLMODAL);
		  break;
		  }
		OutputImage=PickBuffer("Mode filtered",ActiveImage,ActiveROWS,ActiveCOLS,1);
		ModeFilter(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,0);
		strcpy(textout,"Mode filtered");
		ActiveImage=OutputImage;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,1);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_SMOOTH_GAUSSIAN:
		if (0) // ActiveBPP != 1)
		  {
		  MessageBox(hWnd,"Image must be single-band (greyscale)","Not applicable",MB_OK | MB_APPLMODAL);
		  break;
		  }
		OutputImage=PickBuffer("Gaussian filtered",ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		GaussianFilter(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,ActiveBPP,FilterSize);
		strcpy(textout,"Gaussian filtered");
		ActiveImage=OutputImage;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_FILTER_3x3:
		FilterSize=0;
		break;
	  case ID_FILTER_5x5:
		FilterSize=1;
		break;
	  case ID_FILTER_7x7:
		FilterSize=2;
		break;
	  case ID_FILTER_9x9:
		FilterSize=3;
		break;
	  case ID_FILTER_11x11:
		FilterSize=4;
		break;

	  case ID_SNAKES_INIT:
		if (SnakesMode == 1  &&  TotalContourPoints > 0)	/* erase existing contour, start over */
		  DrawContourOnImage(ActiveROWS,ActiveCOLS,0);
		TotalContourPoints=0;
		SnakesMode=1;
		hMenu=GetMenu(MainWnd);
		EnableMenuItem(hMenu,ID_SNAKES_RUN,MF_BYCOMMAND | MF_ENABLED);
		EnableMenuItem(hMenu,ID_SNAKES_STOP,MF_BYCOMMAND | MF_ENABLED);
		break;
	  case ID_SNAKES_RUN:
		if (SnakesMode != 1  ||  TotalContourPoints == 0)
		  break;
		SnakesImage=ActiveImage;
		SnakesRows=ActiveROWS;
		SnakesCols=ActiveCOLS;
		SnakesBPP=ActiveBPP;
		SnakesRunning=1;
		_beginthread(RunSnakes,0,MainWnd);	/* start up a child thread to do other work while this thread continues GUI */
		// RunSnakes(hInst,ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		break;
	  case ID_SNAKES_STOP:
		if (SnakesRunning != 1)
		  break;
		SnakesRunning=0;  /* will cause thread to stop */
		DrawContourOnImage(ActiveROWS,ActiveCOLS,0);
		/*
		SnakesMode=0;
		TotalContourPoints=0;
		hMenu=GetMenu(MainWnd);
		EnableMenuItem(hMenu,ID_SNAKES_RUN,MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(hMenu,ID_SNAKES_STOP,MF_BYCOMMAND | MF_GRAYED);
		*/
		break;
	  case ID_HISTOGRAM_THRESH:
		if (ActiveBPP != 1)
		  {
		  MessageBox(hWnd,"Image must be single-band (greyscale)","Not applicable",MB_OK | MB_APPLMODAL);
		  break;
		  }
		OutputImage=PickBuffer("Thresholded",ActiveImage,ActiveROWS,ActiveCOLS,1);
		ThresholdImage(hInst,hWnd,ActiveImage,OutputImage,ActiveROWS,ActiveCOLS);
		strcpy(textout,"Thresholded");
		ActiveImage=OutputImage;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,1);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_HISTOGRAM_INVERT:
		OutputImage=PickBuffer("Inverted",ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvertImage(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		strcpy(textout,"Inverted");
		ActiveImage=OutputImage;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_HISTOGRAM_EQUALIZE:
		OutputImage=PickBuffer("Equalized",ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		HistogramEqualize(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		strcpy(textout,"Equalized");
		ActiveImage=OutputImage;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_HISTOGRAM_RANDOMIZE:
		OutputImage=PickBuffer("Random colors",ActiveImage,ActiveROWS,ActiveCOLS,3);
		RandomColorImage(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		strcpy(textout,"Random colors");
		ActiveImage=OutputImage;
		ActiveBPP=3;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_HISTOGRAM_DISPLAY:
		OutputImage=PickBuffer("Histogram",ActiveImage,266,266,ActiveBPP);
		MakeHistogramImage(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		strcpy(textout,"Histogram");
		ActiveImage=OutputImage; ActiveROWS=ActiveCOLS=266;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_HISTOGRAM_GRAYSCALE_AVG:case ID_HISTOGRAM_GRAYSCALE_RED:
	  case ID_HISTOGRAM_GRAYSCALE_GREEN:case ID_HISTOGRAM_GRAYSCALE_BLUE:
		OutputImage=PickBuffer("Grayed",ActiveImage,ActiveROWS,ActiveCOLS,1);
		if (LOWORD(wParam) == ID_HISTOGRAM_GRAYSCALE_AVG)
		  GrayImage(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,0);
		else if (LOWORD(wParam) == ID_HISTOGRAM_GRAYSCALE_RED)
		  GrayImage(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,1);
		else if (LOWORD(wParam) == ID_HISTOGRAM_GRAYSCALE_GREEN)
		  GrayImage(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,2);
		else
		  GrayImage(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS,3);
		strcpy(textout,"Grayed");
		ActiveImage=OutputImage; ActiveBPP=1;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_EDGES_SOBEL:
		OutputImage=PickBuffer("Sobel gradients",ActiveImage,ActiveROWS,ActiveCOLS,1);
		SobelEdgeDetect(ActiveImage,OutputImage,NULL,ActiveROWS,ActiveCOLS,ActiveBPP);
		strcpy(textout,"Sobel gradients");
		ActiveImage=OutputImage; ActiveBPP=1;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_EDGES_THIN:
		for (i=0; i<ActiveROWS*ActiveCOLS; i++)
		  if (ActiveImage[i] != 0  &&  ActiveImage[i] != 255)
			break;
		if (i != ActiveROWS*ActiveCOLS)
		  {
		  MessageBox(hWnd,"Image must be binary (0 and 255)","Not applicable",MB_OK | MB_APPLMODAL);
		  break;
		  }
		OutputImage=PickBuffer("Thinned",ActiveImage,ActiveROWS,ActiveCOLS,1);
		ThinEdgeImage(ActiveImage,OutputImage,ActiveROWS,ActiveCOLS);
		strcpy(textout,"Thinned");
		ActiveImage=OutputImage; ActiveBPP=1;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_MASK_COMPUTE:
		if (ActiveBPP != 3)
		  {
		  MessageBox(hWnd,"Image must be RGB","Not applicable",MB_OK | MB_APPLMODAL);
		  break;
		  }
		OutputImage=PickBuffer("STARE Image Mask",ActiveImage,ActiveROWS,ActiveCOLS,1);
		ComputeStareMask(ActiveImage,ActiveROWS,ActiveCOLS,OutputImage);
		strcpy(textout,"STARE Image Mask");
		ActiveImage=OutputImage; ActiveBPP=1;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_MASK_OVERLAY:
		OutputImage=PickBuffer("Mask Overlayed",ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		OverlayStareMask(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP,OutputImage);
		strcpy(textout,"Mask Overlayed");
		ActiveImage=OutputImage;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_VESSELS_MSF:
		if (ActiveBPP != 3)
		  {
		  MessageBox(hWnd,"Image must be RGB","Not applicable",MB_OK | MB_APPLMODAL);
		  break;
		  }
		OutputImage=PickBuffer("MSF Vessels",ActiveImage,ActiveROWS,ActiveCOLS,1);
		MatchSpatialFilterVessels(ActiveImage,ActiveROWS,ActiveCOLS,OutputImage);
		strcpy(textout,"MSF Vessels");
		ActiveImage=OutputImage; ActiveBPP=1;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_VESSELS_NET:
		if (ActiveBPP != 1)
		  {
		  MessageBox(hWnd,"Image must be Greyscale","Not applicable",MB_OK | MB_APPLMODAL);
		  break;
		  }
		OutputImage=PickBuffer("Vessels Network",ActiveImage,ActiveROWS,ActiveCOLS,1);
		ProbeVesselNetwork(ActiveImage,ActiveROWS,ActiveCOLS,OutputImage);
		strcpy(textout,"Vessels Network");
		ActiveImage=OutputImage; ActiveBPP=1;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_VESSELS_PROBE_PARAMETERS:
		DialogBox(hInst,"ID_PROBE_PARAM_DIALOG",hWnd,(DLGPROC)ProbeParamsProc);
		break;
	  case ID_STARE_FUZZY_CONVERGENCE:
		if (ActiveBPP != 1)
		  {
		  MessageBox(hWnd,"Image must be Greyscale","Not applicable",MB_OK | MB_APPLMODAL);
		  break;
		  }
		OutputImage=PickBuffer("Fuzzy Convergence",ActiveImage,ActiveROWS,ActiveCOLS,1);
		FuzzyConvergence(ActiveImage,ActiveROWS,ActiveCOLS,OutputImage);
		strcpy(textout,"Fuzzy Convergence");
		ActiveImage=OutputImage; ActiveBPP=1;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_STARE_BRIGHT_AREA:
		OutputImage=PickBuffer("Bright Area",ActiveImage,ActiveROWS,ActiveCOLS,1);
		LocateOpticNerve(ActiveImage,ActiveBPP,NULL,ActiveROWS,ActiveCOLS,NULL,NULL,OutputImage);
		strcpy(textout,"Bright Area");
		ActiveImage=OutputImage; ActiveBPP=1;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_STARE_EQUALIZE:
		if (MaskBottomRow == 9999)
		  {
		  MessageBox(hWnd,"Must compute a mask first","Error",MB_OK | MB_APPLMODAL);
		  break;
		  }
		OutputImage=PickBuffer("Equalized",ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		EqualizeIllumination(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP,OutputImage);
		strcpy(textout,"Equalized");
		ActiveImage=OutputImage;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_LABEL_UNPAINT:
		PaintLabelImage(0,0,1);
	    MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		hMenu=GetMenu(MainWnd);
		EnableMenuItem(hMenu,ID_LABEL_UNPAINT,MF_BYCOMMAND | MF_GRAYED);
		break;
	  case ID_LABELS_EDIT:
		DisplayLabels=(DisplayLabels+1)%2;
		if (DisplayLabels == 1  &&  LabelImage == NULL)
		  {
		  if ((LabelImage=(unsigned char *)calloc(ROWS*COLS,1)) == NULL)
			{
			MessageBox(MainWnd,"Unable to allocate memory","LabelsImage[]",
				MB_OK | MB_APPLMODAL);
			DisplayLabels=0;
			}
		  }
		hMenu=GetMenu(MainWnd);
		if (DisplayLabels)
		  CheckMenuItem(hMenu,ID_LABELS_EDIT,MF_BYCOMMAND | MF_CHECKED);
		else
		  CheckMenuItem(hMenu,ID_LABELS_EDIT,MF_BYCOMMAND | MF_UNCHECKED);
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_LABEL_SET:
		DialogBox(hInst,"ID_LABEL_DIALOG",hWnd,(DLGPROC)EditLabelProc);
		break;
	  case ID_LABEL_HELP:
		if (OriginalImage == NULL)
		  MessageBox(hWnd,"Load the image to be labeled using File->Load image",
					  "Help",MB_OK | MB_APPLMODAL);
		else if (LabelImage == NULL)
		  MessageBox(hWnd,"To start a new labeling select Labeling->Edit labels;\nTo resume a previous labeling select File->Load labels",
					  "Help",MB_OK | MB_APPLMODAL);
		else if (ScaleImageToWindow == 1  ||  MagFact < 4)
		  MessageBox(hWnd,"Select Display->set magnifcation factor;\nDeselect `scale image to window';\nSet magnifaction to at least 4",
					  "Help",MB_OK | MB_APPLMODAL);
		else 
		  {
		  MessageBox(hWnd,"Left button labels pixel;\nRight button unlabels pixel;\nShift + left button fills area",
					  "Help",MB_OK | MB_APPLMODAL);
		  MessageBox(hWnd,"To toggle seeing labels select Labeling->edit labels",
					  "Help",MB_OK | MB_APPLMODAL);
		  MessageBox(hWnd,"To save labeling select File->save labels; type `filename.ppm' over `*.P?M'",
					  "Help",MB_OK | MB_APPLMODAL);
		  }
		break;
	  case ID_DISPLAY_MAGFACT:
		DialogBox(hInst,"ID_MAGFACT_DIALOG",hWnd,(DLGPROC)MagFactProc);
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		break;
	  case ID_FILE_LABEL_LOAD:
		image_type=-1;
		if (!(SetFilename(hInst,hWnd,label_filename,&image_type)))
		  break;
		if (LabelImage != NULL)
		  free(LabelImage);
		LabelImage=NULL;
		i=ReadImage(label_filename,&LabelImage,&r,&c);
		if (i != 1  ||  r != ROWS  ||  c != COLS)
		  {
		  if (i == 0)
		    MessageBox(hWnd,label_filename,"Cannot read file:",MB_APPLMODAL | MB_OK);
		  else
		    MessageBox(hWnd,label_filename,"Image must be 8-bit and same size as original loaded.",MB_APPLMODAL | MB_OK);
		  free(LabelImage);
		  LabelImage=NULL;
		  strcpy(label_filename,"");
		  break;
		  }
		strcpy(textout,label_filename);
		ActiveBPP=1;
		ActiveImage=LabelImage; ActiveROWS=ROWS; ActiveCOLS=COLS;
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		hMenu=GetMenu(MainWnd);
		EnableMenuItem(hMenu,ID_LABEL_UNPAINT,MF_BYCOMMAND | MF_GRAYED);
		break;
	  case ID_FILE_LABEL_SAVE:
		image_type=-1;
		if (!(SetFilename(hInst,hWnd,label_filename,&image_type)))
		  break;
		if (WriteImage(label_filename,LabelImage,ROWS,COLS,1,1) == 0)
		  MessageBox(hWnd,label_filename,"Cannot write file:",MB_APPLMODAL | MB_OK);
		else
		  MessageBox(hWnd,label_filename,"File saved:",MB_APPLMODAL | MB_OK);
		break;

      case ID_EXIT:case ID_FILE_QUIT:
		if (OriginalImage != NULL) free(OriginalImage);
		if (Buffer1Image != NULL) free(Buffer1Image);
		if (Buffer2Image != NULL) free(Buffer2Image);
		if (Buffer3Image != NULL) free(Buffer3Image);
        DestroyWindow(hWnd);
        break;
      }
    break;
  case WM_SIZE:
	if (hWnd != MainWnd  ||  GetUpdateRect(hWnd,NULL,FALSE) == 0)
	  {
      return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	  break;
	  }
    MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
	PaintImage();
	if (SnakesMode == 1)
	  DrawContourOnImage(ActiveROWS,ActiveCOLS,1);
	// scroll bars cause resizing which causes flicker
	// when invalidateRect method is used to redraw
	//	InvalidateRect(hWnd,NULL,TRUE);
	//	UpdateWindow(hWnd);
	break;
  case WM_PAINT:
	if (hWnd != MainWnd  ||  GetUpdateRect(hWnd,NULL,FALSE) == 0)
	  {
      return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	  break;
	  }
	PaintImage();
	if (SnakesMode == 1)
	  DrawContourOnImage(ActiveROWS,ActiveCOLS,1);
	hDC=GetDC(MainWnd);
	TextOut(hDC,0,0,textout,strlen(textout));
	ReleaseDC(MainWnd,hDC);
    return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	break;
  case WM_CHAR:
	if ((TCHAR)wParam == '['  ||  (TCHAR)wParam == '{'  ||  (TCHAR)wParam == ']'  ||  (TCHAR)wParam == '}')
	  {
	  if (((TCHAR)wParam == '['  ||  (TCHAR)wParam == '{')  &&  FilenameIndex > 0)
		FilenameIndex--;
	  else if (((TCHAR)wParam == ']'  ||  (TCHAR)wParam == '}')  &&  FilenameIndex < TotalFilenames-1)
		FilenameIndex++;
	  else
		break;	  /* no change; do not reload */
	  strcpy(image_filename,FilenameList[FilenameIndex]);
	  strcpy(CurrentPath,image_filename);
	  i=strlen(CurrentPath)-1;
	  while (i > 0  &&  CurrentPath[i] != '\\')
		i--;
	  CurrentPath[i]='\0';
	  SetCurrentDirectory(CurrentPath);
	  if (OriginalImage != NULL)
		free(OriginalImage);
	  OriginalImage=NULL;
	  ROWS=COLS=0;
	  if (Buffer1Image != NULL) { free(Buffer1Image); Buffer1Image=NULL; }
	  if (Buffer2Image != NULL) { free(Buffer2Image); Buffer2Image=NULL; }
	  if (Buffer3Image != NULL) { free(Buffer3Image); Buffer3Image=NULL; }
	  if (LabelImage != NULL) { free(LabelImage); LabelImage=NULL; }
	  if ((OriginalBPP=ReadImage(image_filename,&OriginalImage,&ROWS,&COLS)) == 0)
		{

		MessageBox(hWnd,image_filename,"Cannot read file:",MB_APPLMODAL | MB_OK);
		strcpy(image_filename,"");
		ROWS=COLS=OriginalBPP=0;
		OriginalImage=NULL;
		strcpy(textout,"No image loaded");
		strcpy(image_filename,"");
		}
	  else
		strcpy(textout,image_filename);
	  ActiveBPP=OriginalBPP;
	  ActiveImage=OriginalImage; ActiveROWS=ROWS; ActiveCOLS=COLS;
	  MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
	  InvalidateRect(hWnd,NULL,TRUE);
	  UpdateWindow(hWnd);
	  }
	break;
  case WM_RBUTTONDOWN:
	xPos=LOWORD(lParam);
	yPos=HIWORD(lParam);
	GetImageValue(&xPos,&yPos,ActiveROWS,ActiveCOLS,&red,&green,&blue);	// converts screen x,y to image x,y as well
	if (DisplayLabels == 1)	  /* check if in label mode -- erase pixel */
	  {
	  SetLabelImage(LOWORD(lParam),HIWORD(lParam),xPos,yPos,0 /* unlabel */);
	  break;
	  }
	if (SnakesMode == 1) /* check if in snake mode -- drawing contour */
	  {
	  if (TotalContourPoints >= MAX_CONTOUR_PTS)
		break;
	  ContourX[TotalContourPoints]=xPos;
	  ContourY[TotalContourPoints]=yPos;
	  TotalContourPoints++;
	  DrawContourOnImage(ActiveROWS,ActiveCOLS,1);
	  break;
	  }
    return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	break;
  case WM_LBUTTONDOWN:
	xPos=LOWORD(lParam);
	yPos=HIWORD(lParam);
	GetImageValue(&xPos,&yPos,ActiveROWS,ActiveCOLS,&red,&green,&blue);
	if (DisplayLabels == 1)	/* if in label mode -- set pixel */
	  {
	  if (wParam & MK_SHIFT)
		{		// paint-fill
		PaintLabelImage(xPos,yPos,0);
		MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		hMenu=GetMenu(MainWnd);
		EnableMenuItem(hMenu,ID_LABEL_UNPAINT,MF_BYCOMMAND | MF_ENABLED);
		}
	  SetLabelImage(LOWORD(lParam),HIWORD(lParam),xPos,yPos,Label);
	  break;
	  }
    return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	break;
  case WM_MOUSEMOVE:
	xPos=LOWORD(lParam);
	yPos=HIWORD(lParam);
	GetImageValue(&xPos,&yPos,ActiveROWS,ActiveCOLS,&red,&green,&blue);
	if (SnakesMode == 1  &&  (wParam & MK_RBUTTON)  &&  TotalContourPoints < MAX_CONTOUR_PTS)
	  {
	  ContourX[TotalContourPoints]=xPos;
	  ContourY[TotalContourPoints]=yPos;
	  TotalContourPoints++;
	  DrawContourOnImage(ActiveROWS,ActiveCOLS,1);
	  }
	if (DisplayLabels == 1  &&  (wParam & MK_LBUTTON))
	  SetLabelImage(LOWORD(lParam),HIWORD(lParam),xPos,yPos,Label);
	if (DisplayLabels == 1  &&  (wParam & MK_RBUTTON))	/* unlabel */
	  SetLabelImage(LOWORD(lParam),HIWORD(lParam),xPos,yPos,0 /* unlabel */);
	if (ShowPixelCoords == 0)
      return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	if (DisplayLabels == 1  &&  LabelImage != NULL)
	  sprintf(text,"(%d,%d) => [%d,%d,%d] {%d}",xPos,yPos,
		  red,green,blue,LabelImage[yPos*COLS+xPos]);
	else
	  sprintf(text,"(%d,%d) => [%d,%d,%d]",xPos,yPos,red,green,blue);
	hDC=GetDC(MainWnd);
	GetClientRect(MainWnd,&TextRect);
    TextRect.top=TextRect.bottom-18;
    DrawBrush=CreateSolidBrush(RGB(255,255,255));
    FillRect(hDC,&TextRect,DrawBrush);
    DeleteObject(DrawBrush);
	TextOut(hDC,0,TextRect.top,text,strlen(text));
	ReleaseDC(MainWnd,hDC);
    return(DefWindowProc(hWnd,uMsg,wParam,lParam));
	break;
  case WM_HSCROLL:	// boundary checking done in MakeDisplayImage()
	if (LOWORD(wParam) == SB_LINELEFT) LeftDispCol--;
	if (LOWORD(wParam) == SB_LINERIGHT) LeftDispCol++;
	if (LOWORD(wParam) == SB_PAGELEFT) LeftDispCol-=COLS/6;
	if (LOWORD(wParam) == SB_PAGERIGHT) LeftDispCol+=COLS/6;
	if (LOWORD(wParam) == SB_THUMBPOSITION) LeftDispCol=HIWORD(wParam);
	MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
	PaintImage();
	// as with resizing, direct paintImage calls eliminate flicker
	//	InvalidateRect(hWnd,NULL,TRUE);
	//	UpdateWindow(hWnd);
	break;
  case WM_VSCROLL:	// boundary checking done in MakeDisplayImage()
	if (LOWORD(wParam) == SB_LINEUP) TopDispRow--;
	if (LOWORD(wParam) == SB_LINEDOWN) TopDispRow++;
	if (LOWORD(wParam) == SB_PAGEUP) TopDispRow-=ROWS/6;
	if (LOWORD(wParam) == SB_PAGEDOWN) TopDispRow+=ROWS/6;
	if (LOWORD(wParam) == SB_THUMBPOSITION) TopDispRow=HIWORD(wParam);
	MakeDisplayImage(ActiveImage,ActiveROWS,ActiveCOLS,ActiveBPP);
	PaintImage();
	// as with resizing, direct paintImage calls eliminate flicker
	//	InvalidateRect(hWnd,NULL,TRUE);
	//	UpdateWindow(hWnd);
	break;
  case WM_DESTROY:
    PostQuitMessage(0);
    break;
  default:
    return(DefWindowProc(hWnd,uMsg,wParam,lParam));
    break;
  }

hMenu=GetMenu(MainWnd);
if (OriginalImage != NULL)
  EnableValue=MF_ENABLED;
else
  EnableValue=MF_GRAYED;
EnableMenuItem(hMenu,ID_WINDOW_LASTLOADED,MF_BYCOMMAND | EnableValue);
EnableMenuItem(hMenu,ID_FILE_SAVE,MF_BYCOMMAND | EnableValue);
EnableMenuItem(hMenu,ID_FILE_DISPLAY_SAVE,MF_BYCOMMAND | EnableValue);
EnableMenuItem(hMenu,ID_FILE_LABEL_LOAD,MF_BYCOMMAND | EnableValue);
EnableMenuItem(hMenu,ID_LABELS_EDIT,MF_BYCOMMAND | EnableValue);

if (Buffer1Image != NULL)
  EnableMenuItem(hMenu,ID_WINDOW_BUFFER1,MF_BYCOMMAND | MF_ENABLED);
else
  EnableMenuItem(hMenu,ID_WINDOW_BUFFER1,MF_BYCOMMAND | MF_GRAYED);
if (Buffer2Image != NULL)
  EnableMenuItem(hMenu,ID_WINDOW_BUFFER2,MF_BYCOMMAND | MF_ENABLED);
else
  EnableMenuItem(hMenu,ID_WINDOW_BUFFER2,MF_BYCOMMAND | MF_GRAYED);
if (Buffer3Image != NULL)
  EnableMenuItem(hMenu,ID_WINDOW_BUFFER3,MF_BYCOMMAND | MF_ENABLED);
else
  EnableMenuItem(hMenu,ID_WINDOW_BUFFER3,MF_BYCOMMAND | MF_GRAYED);

if (LabelImage != NULL)
  EnableValue=MF_ENABLED;
else
  EnableValue=MF_GRAYED;
EnableMenuItem(hMenu,ID_WINDOW_LABELS,MF_BYCOMMAND | EnableValue);
EnableMenuItem(hMenu,ID_FILE_LABEL_SAVE,MF_BYCOMMAND | EnableValue);

if (ActiveBPP == 3)
  EnableMenuItem(hMenu,ID_HISTOGRAM_GRAYSCALE,MF_BYCOMMAND | MF_ENABLED);
else
  EnableMenuItem(hMenu,ID_HISTOGRAM_GRAYSCALE,MF_BYCOMMAND | MF_GRAYED);

CheckMenuItem(hMenu,ID_FILTER_3x3,MF_UNCHECKED);
CheckMenuItem(hMenu,ID_FILTER_5x5,MF_UNCHECKED);
CheckMenuItem(hMenu,ID_FILTER_7x7,MF_UNCHECKED);
CheckMenuItem(hMenu,ID_FILTER_9x9,MF_UNCHECKED);
CheckMenuItem(hMenu,ID_FILTER_11x11,MF_UNCHECKED);
if (FilterSize == 4)
  CheckMenuItem(hMenu,ID_FILTER_11x11,MF_CHECKED);
else if (FilterSize == 3)
  CheckMenuItem(hMenu,ID_FILTER_9x9,MF_CHECKED);
else if (FilterSize == 2)
  CheckMenuItem(hMenu,ID_FILTER_7x7,MF_CHECKED);
else if (FilterSize == 1)
  CheckMenuItem(hMenu,ID_FILTER_5x5,MF_CHECKED);
else  /* FilterSize == 0 or default just in case */
  CheckMenuItem(hMenu,ID_FILTER_3x3,MF_CHECKED);


DrawMenuBar(hWnd);

return(0L);
}



unsigned char *PickBuffer(char *name,
						  unsigned char *ProcessingImage,	/* make sure not one of the buffers */
						  int NewROWS,int NewCOLS,
						  int BytesPerPixel)

{
unsigned char *ReturnBuffer;

if (Buffer1Image == NULL)
  {
  if ((Buffer1Image=(unsigned char *)calloc(NewROWS*NewCOLS*BytesPerPixel,1)) == NULL)
    ReturnBuffer=NULL;
  else
	ReturnBuffer=Buffer1Image;
  strcpy(buffer1_name,name);
  Buffer1BPP=BytesPerPixel;
  ROWS1=NewROWS; COLS1=NewCOLS;
  }
else if (Buffer2Image == NULL)
  {
  if ((Buffer2Image=(unsigned char *)calloc(NewROWS*NewCOLS*BytesPerPixel,1)) == NULL)
    ReturnBuffer=NULL;
  else
	ReturnBuffer=Buffer2Image;
  strcpy(buffer2_name,name);
  Buffer2BPP=BytesPerPixel;
  ROWS2=NewROWS; COLS2=NewCOLS;
  }
else if (Buffer3Image == NULL)
  {
  if ((Buffer3Image=(unsigned char *)calloc(NewROWS*NewCOLS*BytesPerPixel,1)) == NULL)
    ReturnBuffer=NULL;
  else
	ReturnBuffer=Buffer3Image;
  strcpy(buffer3_name,name);
  Buffer3BPP=BytesPerPixel;
  ROWS3=NewROWS; COLS3=NewCOLS;
  }
else
  {
  if (ProcessingImage != Buffer1Image)
    {
    free(Buffer1Image);
    Buffer1Image=Buffer2Image;
    strcpy(buffer1_name,buffer2_name);
    Buffer1BPP=Buffer2BPP;
    ROWS1=ROWS2; COLS1=COLS2;
	}
  else
	free(Buffer2Image);
  Buffer2Image=Buffer3Image;
  strcpy(buffer2_name,buffer3_name);
  Buffer2BPP=Buffer3BPP;
  ROWS2=ROWS3; COLS2=COLS3;
  if ((Buffer3Image=(unsigned char *)calloc(NewROWS*NewCOLS*BytesPerPixel,1)) == NULL)
    ReturnBuffer=NULL;
  else
  ReturnBuffer=Buffer3Image;
  strcpy(buffer3_name,name);
  Buffer3BPP=BytesPerPixel;
  ROWS3=NewROWS; COLS3=NewCOLS;
  }
if (ReturnBuffer == NULL)
  MessageBox(MainWnd,"Error -- out of memory","Crash",MB_OK | MB_APPLMODAL);
return(ReturnBuffer);
}
