
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#include <windows.h>
#include "globals.h"
#include "resource.h"

#define	SNAKE_ROWS	400
#define	SNAKE_COLS	400
static unsigned char *snake_image;

static int	  iter,w,skippage,sleepage;
static int	  eww[5];



void PaintSnakeImage()

{
PAINTSTRUCT			Painter;
HDC					hDC;
BITMAPINFOHEADER	bm_info_header;
BITMAPINFO			bm_info;

ShowWindow(SnakeWnd,SW_SHOWNORMAL);
UpdateWindow(SnakeWnd);
BeginPaint(SnakeWnd,&Painter);
hDC=GetDC(SnakeWnd);
bm_info_header.biSize=sizeof(BITMAPINFOHEADER); 
bm_info_header.biWidth=SNAKE_COLS;
bm_info_header.biHeight=-SNAKE_ROWS; 
bm_info_header.biPlanes=1;
bm_info_header.biBitCount=24; 
bm_info_header.biCompression=BI_RGB; 
bm_info_header.biSizeImage=0; 
bm_info_header.biXPelsPerMeter=0; 
bm_info_header.biYPelsPerMeter=0;
bm_info_header.biClrUsed=0; 
bm_info_header.biClrImportant=0;
// bm_info.bmiColors=NULL;
bm_info.bmiHeader=bm_info_header;
SetDIBitsToDevice(hDC,0,0,SNAKE_COLS,SNAKE_ROWS,0,0,
			  0, /* first scan line */
			  SNAKE_ROWS, /* number of scan lines */
			  snake_image,&bm_info,DIB_RGB_COLORS);
ReleaseDC(SnakeWnd,hDC);
EndPaint(SnakeWnd,&Painter);
}



LRESULT CALLBACK SnakeParamsProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)

{
BOOL		Success;

switch(uMsg)
  {
  case WM_INITDIALOG:
	SetDlgItemInt(hDlg,ID_EDIT_ITER,iter,FALSE);
	SetDlgItemInt(hDlg,ID_EDIT_CONT,eww[0],FALSE);
	SetDlgItemInt(hDlg,ID_EDIT_LIN,eww[1],FALSE);
	SetDlgItemInt(hDlg,ID_EDIT_GRAD,eww[2],FALSE);
	SetDlgItemInt(hDlg,ID_EDIT_SKIP,skippage,FALSE);
	SetDlgItemInt(hDlg,ID_EDIT_SLEEP,sleepage,FALSE);
	SetDlgItemInt(hDlg,ID_EDIT_WIND,w,FALSE);
	break;
  case WM_COMMAND:
	switch(LOWORD(wParam))
	  {
	  case ID_EDIT_ITER:
		iter=GetDlgItemInt(hDlg,ID_EDIT_ITER,&Success,FALSE);
		break;
	  case ID_EDIT_CONT:
		eww[0]=GetDlgItemInt(hDlg,ID_EDIT_CONT,&Success,FALSE);
		break;
	  case ID_EDIT_LIN:
		eww[1]=GetDlgItemInt(hDlg,ID_EDIT_LIN,&Success,FALSE);
		break;
	  case ID_EDIT_GRAD:
		eww[2]=GetDlgItemInt(hDlg,ID_EDIT_GRAD,&Success,FALSE);
		break;
	  case ID_EDIT_SKIP:
		skippage=GetDlgItemInt(hDlg,ID_EDIT_SKIP,&Success,FALSE);
		break;
	  case ID_EDIT_SLEEP:
		sleepage=GetDlgItemInt(hDlg,ID_EDIT_SLEEP,&Success,FALSE);
		break;
	  case ID_EDIT_WIND:
		w=GetDlgItemInt(hDlg,ID_EDIT_WIND,&Success,FALSE);
		break;
	  case IDOK:
		EndDialog(hDlg,IDOK);
		break;
	  }
	break;
  default:
	return(FALSE);
  }
return(TRUE);
}









MoveContour(EdgeMagnitudeImage,EdgeDirectionImage,NRows,NCols,
	x,y,TotalPoints,w,ew,Direction,nw,PtsMoved)

unsigned char	*EdgeMagnitudeImage;	/* edge strength image; values 0..255 */
unsigned char	*EdgeDirectionImage;	/* edge direction image; values 0..255;
					**  0..360 degrees scaled to 0..255 */
int		NRows,NCols;		/* size of image(s) */
int		*x,*y;			/* X,Y (column,row) coordinates of
					**  points in contour */
int		TotalPoints;		/* total points in contour */
int		w;			/* neighborhood window size is NxN,
					**  where N=2*w+1 */
float		ew[5];			/* energy weights; they are relative
					**  to each other, so, technically,
					**  they can have any positive value;
					**  however, recommend 0.0...5.0 */
int		Direction;		/* direction of processing points in
					**  contour; 1 => 0..TotalPoints;
					**  -1 => TotalPoints..0 */
int		nw;			/* for spatially related energy terms,
					**  describes the size of the window
					**  to normalize in (ie, can be
					**  different from `w').  This is
					**  essential for comparing the same
					**  `ew's at different `w's.
					**  0 => same window as `w'; otherwise,
					**  computed just as `w'. */
int		*PtsMoved;		/* returned value; how many points
					**  were moved during the iteration */

{
float		total,DAvg,Curv1,Curv2,EnergyMin,EnergyMax;
int			i,n,r,c,Max,Min,InNormWindow,MoveX,MoveY;
float		EnergyContMax,EnergyLinMax,EnergyDirMax,EnergyCurvMax;
float		**Energy,**EnergyDir,**EnergyLin;
float		**EnergyEdgeStrength,**EnergyCurv,**EnergyCont;
int			*NewCoordsX,*NewCoordsY;
int			MidX,MidY,WindowX,WindowY;
double		dist;

	/* Allocate memory for all energy terms for window size. */

n=2*w+1;
Energy=(float **)calloc(n,sizeof(float *));
EnergyDir=(float **)calloc(n,sizeof(float *));
EnergyLin=(float **)calloc(n,sizeof(float *));
EnergyCurv=(float **)calloc(n,sizeof(float *));
EnergyCont=(float **)calloc(n,sizeof(float *));
EnergyEdgeStrength=(float **)calloc(n,sizeof(float *));
NewCoordsX=(int *)calloc(TotalPoints,sizeof(int));
NewCoordsY=(int *)calloc(TotalPoints,sizeof(int));
for (i=0; i<n; i++)
  {
  Energy[i]=(float *)calloc(n,sizeof(float));
  EnergyDir[i]=(float *)calloc(n,sizeof(float));
  EnergyLin[i]=(float *)calloc(n,sizeof(float));
  EnergyCurv[i]=(float *)calloc(n,sizeof(float));
  EnergyCont[i]=(float *)calloc(n,sizeof(float));
  EnergyEdgeStrength[i]=(float *)calloc(n,sizeof(float));
  }

	/* Total distances between all points in contour. */

total=0.0;
for (i=0; i<TotalPoints; i++)
  total=total+(float)sqrt((double)((x[i]-x[i])*(x[i]-x[i])+
	(y[i]-y[i])*(y[i]-y[i])));

DAvg=total/(float)(TotalPoints-1);	/* DAvg => average dist between 2 pts */
(*PtsMoved)=0;				/* PtsMoved => # pts moved in 1 iter. */
if (Direction >= 0)			/* which direction to travel contour */
  i=0;					/* process points from 0..TotalPoints */
else
  i=TotalPoints;			/* process points from TotalPoints..0 */
do
  {
  Max=0;				/* Max & Min terms => max & min abs */
  Min=255;				/*  values for energies in window */
  EnergyContMax=EnergyLinMax=EnergyDirMax=EnergyCurvMax=0.0;

	/* There are two passes through the neighborhood.  The first */
	/*  computes absolute Energy values for each term, and finds */
	/*  the max (and min for edge str) for each energy term so */
	/*  they can be normalized during the second pass. */

  for (r=-w; r<=w; r++)			/* size of neighborhood to check is...*/
	{					/* ...NxN, where N=(2*w)+1 */
	for (c=-w; c<=w; c++)			/* examples: 3x3 => w=1; 5x5 => w=2 */
	  {					/*  c <==> x  and r <==> y */

	  /* First thing to do is to check image boundaries.  To keep */
	  /*  a point from moving off the image, any neighborhood point */
	  /*  out-of-bounds gets its energy set very large.  Since the */
	  /*  whole idea is to minimize a point's energy, the point */
	  /*  will never take the out-of-bounds route. */

	  if ((x[i]+c) < 0  ||  (x[i]+c) >= NCols  ||  (y[i]+r) < 0  ||  (y[i]+r) >= NRows)
		Energy[r+w][c+w]=1.0e+6;		/* no moving past image boundaries */
	  else
		{

	  /* To avoid checking boundaries for normalization window at
	  **  every 'if', InNormWindow is defined (1 => in norm window).
	  **  This only applies to the spatially-related energy terms:
	  **  EnergyCont, EnergyLin, EnergyCurv. */

		if (nw == 0  ||  ((r+w) >= -nw  &&  (r+w) <= nw  &&
		  (c+w) >= -nw  &&  (c+w) <= nw))
		  InNormWindow=1;
		else
		  InNormWindow=0;

		Energy[r+w][c+w]=0.0;		/* initial Energy at each possible pt */
		n=TotalPoints;			/* n <==> TotalPoints; easier index */

	  /* EnergyCont => continuity; how evenly spaced the points on the
	  **  contour are.  The distance between the point and the point
	  **  behind it is compared to DAvg.  The closer, the lower the
	  **  energy. */

		EnergyCont[r+w][c+w]=DAvg-(float)sqrt((double)((x[i]+c-x[(i-1+n)%n])*
			  (x[i]+c-x[(i-1+n)%n])+(y[i]+r-y[(i-1+n)%n])*(y[i]+r-y[(i-1+n)%n])));
		if (EnergyCont[r+w][c+w] < 0.0)
		  EnergyCont[r+w][c+w]=-EnergyCont[r+w][c+w];
		if (EnergyCont[r+w][c+w] > EnergyContMax  &&  InNormWindow == 1)
		  EnergyContMax=EnergyCont[r+w][c+w];

	  /* EnergyLin => linearality; how well the point, plus the points on
	  **  either side, make a straight line.  The straighter, the lower
	  **  the energy. */

		/*
		EnergyLin[r+w][c+w]=(float)((x[(i-1+n)%n]-(2*(x[i]+c))+
			  x[(i+1)%n])*(x[(i-1+n)%n]-(2*(x[i]+c))+x[(i+1)%n])+
			  (y[(i-1+n)%n]-(2*(y[i]+r))+y[(i+1)%n])*(y[(i-1+n)%n]-
			  (2*(y[i]+r))+y[(i+1)%n]));
		*/
		MidX=(x[(i-1+n)%n]+x[(i+1)%n])/2;
		MidY=(y[(i-1+n)%n]+y[(i+1)%n])/2;
		WindowX=x[i]+c;
		WindowY=y[i]+r;
		dist=sqrt((double)(SQR(MidX-WindowX)+SQR(MidY-WindowY)));
		EnergyLin[r+w][c+w]=(float)dist;

		if (EnergyLin[r+w][c+w] > EnergyLinMax  &&  InNormWindow == 1)
		  EnergyLinMax=EnergyLin[r+w][c+w];

	  /* Max, Min => edge strength max & min in window */

		if (EdgeMagnitudeImage[(y[i]+r)*NCols+x[i]+c] > Max)
		  Max=EdgeMagnitudeImage[(y[i]+r)*NCols+x[i]+c];
		if (EdgeMagnitudeImage[(y[i]+r)*NCols+x[i]+c] < Min)
		  Min=EdgeMagnitudeImage[(y[i]+r)*NCols+x[i]+c];

	  /* EnergyDir => edge direction; how well the point's edge direction
	  **  matches the points' on either side edge directions. */

		EnergyDir[r+w][c+w]=(float)sqrt((double)
			  ((EdgeDirectionImage[(y[i]+r)*NCols+x[i]+c]-
			  EdgeDirectionImage[y[(i-1+n)%n]*NCols+x[(i-1+n)%n]])*
			  (EdgeDirectionImage[(y[i]+r)*NCols+x[i]+c]-
			  EdgeDirectionImage[y[(i-1+n)%n]*NCols+x[(i-1+n)%n]])))+(float)
			  sqrt((double)((EdgeDirectionImage[y[(i+1)%n]*NCols+x[(i+1)%n]]-
			  EdgeDirectionImage[(y[i]+r)*NCols+x[i]+c])*
			  (EdgeDirectionImage[y[(i+1)%n]*NCols+x[(i+1)%n]]-
			  EdgeDirectionImage[(y[i]+r)*NCols+x[i]+c])));
		if (EnergyDir[r+w][c+w] > EnergyDirMax)
		  EnergyDirMax=EnergyDir[r+w][c+w];

	  /* EnergyCurv => curvature matching; how well the curvature of
	  **  this point matches the curvature of the points on either side.
	  **  This is different from EnergyLin, which tries to force a
	  **  uniform curvature of zero.  EnergyCurv tries to force a
	  **  uniform curvature of any value. */

		Curv1=(float)((x[i]+c-(2*x[(i-1+n)%n])+x[(i-2+n)%n])*
			  (x[i]+c-(2*x[(i-1+n)%n])+x[(i-2+n)%n])+
			  (y[i]+r-(2*y[(i-1+n)%n])+y[(i-2+n)%n])*
			  (y[i]+r-(2*y[(i-1+n)%n])+y[(i-2+n)%n]));
		Curv2=(float)((x[(i+2)%n]-(2*x[(i+1)%n])+x[i]+c)*
			  (x[(i+2)%n]-(2*x[(i+1)%n])+x[i]+c)+
			  (y[(i+2)%n]-(2*y[(i+1)%n])+y[i]+r)*
			  (y[(i+2)%n]-(2*y[(i+1)%n])+y[i]+r));
		EnergyCurv[r+w][c+w]=Curv2-Curv1;
		if (EnergyCurv[r+w][c+w] < 0.0)
		  EnergyCurv[r+w][c+w]=-EnergyCurv[r+w][c+w];
		if (EnergyCurv[r+w][c+w] > EnergyCurvMax  &&  InNormWindow == 1)
		  EnergyCurvMax=EnergyCurv[r+w][c+w];
		}
	  }
	}

  if ((Max-Min) < 5)			/* according to greedy algorithm; */
	Max=Min+5;				/* minimum range for edge strength */
  if (EnergyCurvMax < 0.00001)
	EnergyCurvMax=(float)0.1;		/* avoid dividing by zero */

	  /* Second pass:  everything gets normalized, and total  */
	  /*  energy for each neighborhood point is computed. */

  for (r=-w; r<=w; r++)
	{
	for (c=-w; c<=w; c++)
	  {
	  if (Energy[r+w][c+w] == 0.0)	/* make sure in the image (see above) */
		{
		EnergyCont[r+w][c+w]=EnergyCont[r+w][c+w]/EnergyContMax;
		EnergyLin[r+w][c+w]=EnergyLin[r+w][c+w]/EnergyLinMax;
		EnergyEdgeStrength[r+w][c+w]=(float)(Min-
			  (int)EdgeMagnitudeImage[(y[i]+r)*NCols+x[i]+c])/(float)(Max-Min);
		EnergyDir[r+w][c+w]=EnergyDir[r+w][c+w]/EnergyDirMax;
		EnergyCurv[r+w][c+w]=EnergyCurv[r+w][c+w]/EnergyCurvMax;
		Energy[r+w][c+w]=ew[0]*EnergyCont[r+w][c+w]+ew[1]*
			  EnergyLin[r+w][c+w]+ew[2]*EnergyEdgeStrength[r+w][c+w]+
			  ew[3]*EnergyDir[r+w][c+w]+ew[4]*EnergyCurv[r+w][c+w];

		if (r == -w  &&  c == -w)
		  EnergyMax=EnergyMin=Energy[r+w][c+w];
		else
		  {
		  if (Energy[r+w][c+w] > EnergyMax)
			EnergyMax=Energy[r+w][c+w];
		  if (Energy[r+w][c+w] < EnergyMin)
			EnergyMin=Energy[r+w][c+w];
		  }

		snake_image[((r+w)*SNAKE_COLS+c+w)*3+0]=
		snake_image[((r+w)*SNAKE_COLS+c+w)*3+1]=
		snake_image[((r+w)*SNAKE_COLS+c+w)*3+2]=
		  (unsigned char)(EnergyCont[r+w][c+w]*255.0);
		snake_image[((r+w)*SNAKE_COLS+c+w + w*2+1)*3+0]=
		snake_image[((r+w)*SNAKE_COLS+c+w + w*2+1)*3+1]=
		snake_image[((r+w)*SNAKE_COLS+c+w + w*2+1)*3+2]=
		  (unsigned char)(EnergyLin[r+w][c+w]*255.0);
		snake_image[((r+w)*SNAKE_COLS+c+w + 2*(w*2+1))*3+0]=
		snake_image[((r+w)*SNAKE_COLS+c+w + 2*(w*2+1))*3+1]=
		snake_image[((r+w)*SNAKE_COLS+c+w + 2*(w*2+1))*3+2]=
		  (unsigned char)(EnergyCurv[r+w][c+w]*255.0);
		snake_image[((r+w + 1*(w*2+1))*SNAKE_COLS+c+w + 0*(w*2+1))*3+0]=
		snake_image[((r+w + 1*(w*2+1))*SNAKE_COLS+c+w + 0*(w*2+1))*3+1]=
		snake_image[((r+w + 1*(w*2+1))*SNAKE_COLS+c+w + 0*(w*2+1))*3+2]=
		  (unsigned char)(EnergyEdgeStrength[r+w][c+w]*255.0);
		}
	  }
	}

  for (r=-w; r<=w; r++)
	{
	for (c=-w; c<=w; c++)
	  {
	  snake_image[((r+w + 1*(w*2+1))*SNAKE_COLS+c+w + 1*(w*2+1))*3+0]=
	  snake_image[((r+w + 1*(w*2+1))*SNAKE_COLS+c+w + 1*(w*2+1))*3+1]=
	  snake_image[((r+w + 1*(w*2+1))*SNAKE_COLS+c+w + 1*(w*2+1))*3+2]=
		  (unsigned char)((Energy[r+w][c+w]-EnergyMin)/(EnergyMax-EnergyMin)*255.0);
	  }
	}

	/* Find minimum energy in neighborhood. */

  EnergyMin=1.0e+6;			/* start out min energy very large */
  MoveX=MoveY=0;			/* how much to move point */
  for (r=-w; r<=w; r++)
    for (c=-w; c<=w; c++)
      if (Energy[r+w][c+w] < EnergyMin)
        {				/* minimize energy */
        EnergyMin=Energy[r+w][c+w];
        MoveY=r;
        MoveX=c;
        }

  if (0)
	{
	for (r=MoveY-4; r<=MoveY+4; r++)
	  for (c=MoveX-4; c<=MoveX+4; c++)
		{
		snake_image[((1*(w*2+1) + r+w)*SNAKE_COLS+(1*(w*2+1) + c+w))*3+2]=255;
		}
	PaintSnakeImage();
	Sleep(1000);
	}

	/* Move point to new location. */

  NewCoordsX[i]=x[i]+MoveX;
  NewCoordsY[i]=y[i]+MoveY;
  if (MoveX != 0  ||  MoveY != 0)
    (*PtsMoved)++;

	/* Move index to next point, depending on direction of travel. */

  if (Direction >= 0)
    i=i+1;
  else
    i=i-1;

  }	/* ends `i' loop (loop to process one point) */
while ((Direction >= 0  &&  i != TotalPoints)  ||  (Direction < 0  &&  i != -1));

	/* move all points at end */
for (i=0; i<TotalPoints; i++)
  {
  x[i]=NewCoordsX[i];
  y[i]=NewCoordsY[i];
  }

/*
for (i=0; i<n; i++)
  {
  free(Energy[i]);
  free(EnergyDir[i]);
  free(EnergyLin[i]);
  free(EnergyCurv[i]);
  free(EnergyCont[i]);
  free(EnergyEdgeStrength[i]);
  }
free(Energy);
free(EnergyDir);
free(EnergyLin);
free(EnergyCurv);
free(EnergyCont);
free(EnergyEdgeStrength);
free(NewCoordsX);
free(NewCoordsY);
*/

}



/*
void RunSnakes(HINSTANCE hInst,
			   unsigned char *Image,
			   int ImageRows,int ImageCols,int ImageBytes)
*/
void RunSnakes(HWND MainWindowCopy)

{
unsigned char *EdgeMagImage;
unsigned char *EdgeDirImage;
int			  *SnakeX,*SnakeY,TotalSnakePoints;
int			  *LineIndices,TotalLineIndices;
int			  i,j,k,D,nw,PM;
float		  lew[5];
static int	  FirstRun=1;
double		  distance;
unsigned char *Image;
int			  ImageRows,ImageCols,ImageBytes;

  /* copying from globals ... need to simplify this */
Image=SnakesImage;
ImageRows=SnakesRows;
ImageCols=SnakesCols;
ImageBytes=SnakesBPP;

D=0;		// direction (Boolean)
nw=0;		// normalize window size (0 means same as w)
if (FirstRun)
  {
  w=25;		// neighborhood window size
  iter=20;	// #iterations to "snake"
  skippage=20;	// process every Nth point
  sleepage=100; // time to wait between iterations, for viewing
  eww[0]=0;	// continuity
  eww[1]=1;	// linearity
  eww[2]=1;	// gradient strength
  eww[3]=0;	// gradient direction uniformity
  eww[4]=0;	// curvature uniformity
  FirstRun=0;
  snake_image=(unsigned char *)calloc(SNAKE_ROWS*SNAKE_COLS*3,1);
  }

DialogBox(hInst,"ID_SNAKES_DIALOG",MainWnd,(DLGPROC)SnakeParamsProc);

EdgeMagImage=(unsigned char *)calloc(ImageCols*ImageRows,sizeof(unsigned char));
EdgeDirImage=(unsigned char *)calloc(ImageCols*ImageRows,sizeof(unsigned char));
SobelEdgeDetect(Image,EdgeMagImage,EdgeDirImage,ImageRows,ImageCols,ImageBytes);
SnakeX=(int *)calloc(MAX_CONTOUR_PTS,sizeof(int));
SnakeY=(int *)calloc(MAX_CONTOUR_PTS,sizeof(int));
LineIndices=(int *)calloc(MAX_CONTOUR_PTS,sizeof(int));
for (i=0; i<5; i++) lew[i]=(float)eww[i];
TotalSnakePoints=1;
SnakeX[0]=ContourX[0];
SnakeY[0]=ContourY[0];
for (i=1; i<TotalContourPoints; i++)
  {
  distance=sqrt(SQR(ContourX[i]-SnakeX[TotalSnakePoints-1])+SQR(ContourY[i]-SnakeY[TotalSnakePoints-1]));
  if (distance < skippage)
	continue;
  SnakeX[TotalSnakePoints]=ContourX[i];
  SnakeY[TotalSnakePoints]=ContourY[i];
  TotalSnakePoints++;
  }

PaintImage();

for (j=0; j<TotalContourPoints; j++)
  DrawPixelColor(ContourX[j],ContourY[j],ImageRows,ImageCols,-1,8);

for (i=0; i<iter; i++)
  {
  for (j=0; j<TotalSnakePoints; j++)
	{
	DrawPixelColor(SnakeX[j],SnakeY[j],ImageRows,ImageCols,-1,8);
	MakeLineIndices(SnakeX[j],SnakeY[j],SnakeX[(j+1)%TotalSnakePoints],SnakeY[(j+1)%TotalSnakePoints],
			ImageRows,ImageCols,LineIndices,&TotalLineIndices);
	for (k=0; k<TotalLineIndices; k++)
	  DrawPixelColor(LineIndices[k]%ImageCols,LineIndices[k]/ImageCols,ImageRows,ImageCols,-1,2);
	}
  MoveContour(EdgeMagImage,EdgeDirImage,ImageRows,ImageCols,
			  SnakeX,SnakeY,TotalSnakePoints,w,lew,(i%2 == 0 ? 1 : -1),nw,&PM);
  for (j=0; j<TotalSnakePoints; j++)
	{
	DrawPixelColor(SnakeX[j],SnakeY[j],ImageRows,ImageCols,255,8);
	MakeLineIndices(SnakeX[j],SnakeY[j],SnakeX[(j+1)%TotalSnakePoints],SnakeY[(j+1)%TotalSnakePoints],
			ImageRows,ImageCols,LineIndices,&TotalLineIndices);
	for (k=0; k<TotalLineIndices; k++)
	  DrawPixelColor(LineIndices[k]%ImageCols,LineIndices[k]/ImageCols,ImageRows,ImageCols,255,2);
	}
  Sleep(sleepage);
  if (SnakesRunning == 0)
	break;
  }

		/* copy snake into contour array - add in interpolated lines between snake points */
TotalContourPoints=0;
for (i=0; i<TotalSnakePoints; i++)
  {
  ContourX[TotalContourPoints]=SnakeX[i];
  ContourY[TotalContourPoints]=SnakeY[i];
  TotalContourPoints++;
  MakeLineIndices(SnakeX[i],SnakeY[i],SnakeX[(i+1)%TotalSnakePoints],SnakeY[(i+1)%TotalSnakePoints],
			ImageRows,ImageCols,LineIndices,&TotalLineIndices);
  for (k=0; k<TotalLineIndices; k++)
	{
	ContourX[TotalContourPoints]=LineIndices[k]%ImageCols;
	ContourY[TotalContourPoints]=LineIndices[k]/ImageCols;
	TotalContourPoints++;
	}
  }

/*
free(EdgeMagImage);
free(EdgeDirImage);
free(SnakeX);
free(SnakeY);
free(LineIndices);
free(snake_image);
*/
}


